VERSION 5.00
Begin VB.UserControl legend 
   Alignable       =   -1  'True
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000004&
   ClientHeight    =   5550
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3300
   FillStyle       =   0  'Solid
   FontTransparent =   0   'False
   ScaleHeight     =   5550
   ScaleWidth      =   3300
   ToolboxBitmap   =   "SampleLegend.ctx":0000
   Begin VB.PictureBox cmdScrollDownPage 
      Appearance      =   0  'Flat
      BackColor       =   &H80000004&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   210
      Left            =   3015
      Picture         =   "SampleLegend.ctx":0312
      ScaleHeight     =   210
      ScaleWidth      =   210
      TabIndex        =   7
      Top             =   4215
      Width           =   210
   End
   Begin VB.PictureBox cmdScrollDown 
      BorderStyle     =   0  'None
      Height          =   210
      Left            =   3015
      Picture         =   "SampleLegend.ctx":0464
      ScaleHeight     =   210
      ScaleWidth      =   210
      TabIndex        =   6
      Top             =   3975
      Width           =   210
   End
   Begin VB.PictureBox cmdScrollUp 
      BorderStyle     =   0  'None
      Height          =   210
      Left            =   3015
      Picture         =   "SampleLegend.ctx":05B6
      ScaleHeight     =   210
      ScaleWidth      =   210
      TabIndex        =   5
      Top             =   300
      Width           =   210
   End
   Begin VB.PictureBox cmdScrollUpPage 
      BorderStyle     =   0  'None
      Height          =   210
      Left            =   3015
      Picture         =   "SampleLegend.ctx":0708
      ScaleHeight     =   210
      ScaleWidth      =   210
      TabIndex        =   4
      Top             =   45
      Width           =   210
   End
   Begin VB.PictureBox PicPanel 
      Height          =   4425
      Left            =   0
      ScaleHeight     =   4365
      ScaleWidth      =   3195
      TabIndex        =   0
      Top             =   15
      Width           =   3250
      Begin VB.PictureBox picScrollWindow 
         Appearance      =   0  'Flat
         AutoRedraw      =   -1  'True
         BackColor       =   &H80000004&
         BorderStyle     =   0  'None
         ForeColor       =   &H80000008&
         Height          =   30000
         Left            =   0
         ScaleHeight     =   30000
         ScaleWidth      =   3195
         TabIndex        =   1
         Top             =   -360
         Width           =   3200
         Begin VB.PictureBox PicLegend 
            Appearance      =   0  'Flat
            AutoRedraw      =   -1  'True
            BackColor       =   &H00C0C0C0&
            BorderStyle     =   0  'None
            ForeColor       =   &H80000008&
            Height          =   1050
            Index           =   0
            Left            =   15
            ScaleHeight     =   1050
            ScaleWidth      =   3195
            TabIndex        =   3
            Top             =   0
            Width           =   3200
         End
         Begin VB.CheckBox chkLegend 
            BackColor       =   &H80000004&
            ForeColor       =   &H00000000&
            Height          =   225
            Index           =   0
            Left            =   90
            TabIndex        =   2
            Top             =   1425
            Value           =   1  'Checked
            Visible         =   0   'False
            Width           =   240
         End
      End
   End
End
Attribute VB_Name = "legend"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_MapSource As Object
Private m_BackColor As Long
Private m_foreColor As Long
Private m_font As Font
Private m_bActive As Boolean 'active theme
Private m_enabled As Boolean
Private m_enableDragDrop As Boolean
Private m_showLegendCol As New ColThemes

Private f_isLoading As Boolean
Private f_bigGap As Integer
Private f_smallGap As Integer
Private f_curIndex As Integer
Private f_lngScrollTop As Long
Private f_numOfEntries As Integer
Private f_curActiveLayer As Integer
Private f_RendererCaption() As RendererCaption
Private f_TextColor As Long
Private f_StartScrolling As Boolean
Private f_ClickOnRenderer  As Boolean
'Private f_bLoading As Boolean

Private Const LEFT_LBLTHEME As Integer = 345
Private Const LABEL_RENDERER_LEFT As Integer = 690
Private Const PICTURE_RENDERER_LEFT As Integer = 345
Private Const PICTURE_RENDERER_WIDTH As Byte = 13
Private Const PICTURE_RENDERER_HEIGHT As Byte = 13

Private Const SCROLL_DOWN = -250
Private Const SCROLL_UP = 250


'Event Declarations:
Public Event LayerDblClick(Index As Integer)
Attribute LayerDblClick.VB_Description = "Occurs after user double-clicks on the legend control."
Public Event RenderClick(LayerIndex As Integer, BreakIndex As Integer, val1 As Variant, val2 As Variant)
Public Event MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseDown.VB_Description = "Occurs when a user presses a mouse button on the legend control."
Public Event MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse on the legend control."
Public Event MouseUp(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseUp.VB_Description = "Occurs when a user releases a mouse button on the legend control."
Public Event AfterSetLayerVisible(Index As Integer, isVisible As Boolean)
Attribute AfterSetLayerVisible.VB_Description = "Occurs after a user changes layerVisible property or clicks on a check box on the legend control."
Public Event BeforeSetLayerVisible(Index As Integer, cancel As Boolean)
Attribute BeforeSetLayerVisible.VB_Description = "Occurs before a user changes layerVisible property or clicks on a check box on the legend control."
Public Event AfterReorder()

'Type declarations:
' This type stores Symbol information.
Private Type LegendArray
  Symbol As Variant
  label As String
  color As Long
End Type

'This type stores the contents of the renderer caption
Private Type RendererCaption
  Caption As String
  LayerIndex As Integer
  RendererIndex As Integer
End Type

'Declaration for Border style.
Private Enum FrameStyle
  stLowered = 0
  stRaised = 2
  stErase = -1
End Enum

'
' Function providing a Read-Only property of Entry Name.
'
Public Function GetEntryName(Index As Integer) As String
  On Error Resume Next
  GetEntryName = chkLegend(Index).Caption
  If Err.Number <> 0 Then
    Err.Clear
    GetEntryName = ""
  End If
End Function

'
' Two functions providing a Read-Write BackColor property for the Legend control.
'
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
  m_BackColor = New_BackColor
  With UserControl
    .BackColor() = New_BackColor
    '
    ' Back color is replicated to all parts of the control.
    '
    PicPanel.BackColor = .BackColor
    picScrollWindow.BackColor = .BackColor
    PicLegend(0).BackColor = .BackColor
    chkLegend(0).BackColor = .BackColor
    cmdScrollDown.BackColor = .BackColor
    cmdScrollDownPage.BackColor = .BackColor
    cmdScrollUp.BackColor = .BackColor
    cmdScrollUpPage.BackColor = .BackColor
  End With
  PropertyChanged "BackColor"
End Property

'
' Two functions providing a Read-Write ForeColor Property.
'
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = UserControl.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    m_foreColor = New_ForeColor
    With UserControl
      .ForeColor() = New_ForeColor
      chkLegend(0).ForeColor = .ForeColor
    End With
    PropertyChanged "ForeColor"
End Property

'
' Two functions providing a Read-Write Enabled Property.
'
Public Property Get Enabled() As Boolean
    Enabled = True
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    m_enabled = New_Enabled
    PropertyChanged "Enabled"
End Property

'
' Two functions providing a Read-Write EnableDragDrop Property.
'
Public Property Get EnableDragDrop() As Boolean
    EnableDragDrop = m_enableDragDrop
End Property

Public Property Let EnableDragDrop(ByVal New_Enabled As Boolean)
    m_enableDragDrop = New_Enabled
    PropertyChanged "EnableDragDrop"
End Property

'
' Two functions providing a Read-Write Font Property.
'
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns/sets  a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set m_font = New_Font
    With UserControl
      Set .Font = New_Font
      Set PicLegend(0).Font = .Font
    End With
    PropertyChanged "Font"
End Property

'
' Two functions providing a Read-Write BackStyle Property.
'
Public Property Get BackStyle() As Integer
Attribute BackStyle.VB_Description = "Indicates whether a Label or the background of a Shape is transparent or opaque."
    BackStyle = UserControl.BackStyle
End Property

Public Property Let BackStyle(ByVal New_BackStyle As Integer)
    UserControl.BackStyle() = New_BackStyle
    PropertyChanged "BackStyle"
End Property

'
' Two functions providing a Read-Write BorderStyle Property.
'
Public Property Get BorderStyle() As Integer
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
    UserControl.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

'
' Routines providing a Read-Write Font Property.
'
Private Sub chkLegend_Click(Index As Integer)
  ' Check on/off chklegend, raise event for application developer
  ' to control the theme visibility.
  Dim isVisible As Boolean
  If Not f_isLoading Then
    isVisible = IIf(chkLegend(Index).Value = 1, True, False)
    m_MapSource.Layers.Item(Index).Visible = isVisible
    'If Not f_isLoading Then
      'm_MapSource.Refresh
    'End If
    'If m_enabled And (Not f_isLoading) Then
    If m_enabled Then RaiseEvent AfterSetLayerVisible(Index, isVisible)
  End If
End Sub

Private Sub chkLegend_DragDrop(Index As Integer, Source As Control, X As Single, Y As Single)
  dragDrop Index
End Sub

Private Sub cmdScrollDown_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  f_StartScrolling = True
  Scroll SCROLL_DOWN
End Sub

Private Sub cmdScrollDown_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  f_StartScrolling = False
End Sub


Private Sub cmdScrollDownPage_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Dim newTop As Single
  Dim lastPiclegend As PictureBox
  Dim picBottom As Single
  Dim i As Long
  
  f_StartScrolling = True
  Do While f_StartScrolling
    Set lastPiclegend = PicLegend(PicLegend.UBound)
    'get the bottom of the last piclegend (relative to usercontrol)
    picBottom = lastPiclegend.Top + lastPiclegend.Height + f_lngScrollTop
    
    With picScrollWindow
        '.Top = .Top - PicPanel.Height
        If (picBottom - ScaleHeight) < ScaleHeight Then
           .Top = .Top - (picBottom - ScaleHeight) - 50
        Else
          .Top = .Top - ScaleHeight
        End If
        
        f_lngScrollTop = .Top
        .Refresh
    End With
    setScrollBarVisible
    Set lastPiclegend = Nothing
    
    'Forces a delay
    For i = 0 To 1000000
    Next
    DoEvents
  

  Loop


End Sub

Private Sub cmdScrollDownPage_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
   f_StartScrolling = False
End Sub

Private Sub cmdScrollUp_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  f_StartScrolling = True
  Scroll SCROLL_UP
End Sub
Private Sub Scroll(gap As Long)
   Dim i As Long
   Do While f_StartScrolling
     'make some checking
     If gap < 0 Then
      If Abs(picScrollWindow.Top) >= picScrollWindow.Height - ScaleHeight Then GoTo EXIT_Scroll
     Else
      If picScrollWindow.Top >= 0 Then
        picScrollWindow.Top = 0
        GoTo EXIT_Scroll
      End If
     End If
     
     
     picScrollWindow.Top = picScrollWindow.Top + gap 'vsbScrollWindow
     f_lngScrollTop = picScrollWindow.Top
     picScrollWindow.Refresh

     setScrollBarVisible
     
     'force the scroll to delay
     For i = 0 To 100000
     Next
     DoEvents
  Loop
  
EXIT_Scroll:
  f_StartScrolling = False
End Sub

Private Sub cmdScrollUp_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  f_StartScrolling = False
End Sub

Private Sub dragDrop(ToIndex As Integer)
  'On Error Resume Next

  If m_MapSource.Layers.Count > 1 Then
    If ToIndex <> f_curIndex Then
       m_MapSource.Layers.MoveTo f_curIndex, ToIndex
       m_MapSource.Refresh
       LoadLegend
       '
       'maintain the active layer
       If f_curActiveLayer = -1 Then
         Active(ToIndex) = False
       Else
         If f_curActiveLayer = f_curIndex Then
           Active(ToIndex) = True
         ElseIf f_curActiveLayer > f_curIndex Then
           If ToIndex < f_curActiveLayer Then
             Active(f_curActiveLayer) = True
           ElseIf ToIndex >= f_curActiveLayer Then
             Active(f_curActiveLayer - 1) = True
           End If
         Else
           If ToIndex <= f_curActiveLayer Then
             Active(f_curActiveLayer + 1) = True
           Else
             Active(f_curActiveLayer) = True
           End If
         End If
       End If
    End If
    RaiseEvent AfterReorder
  End If
End Sub

Private Sub cmdScrollUpPage_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Dim lastPiclegend As PictureBox
  Dim newTop As Single
  Dim maxHeight As Single
  Dim i As Long
  
  f_StartScrolling = True
  Do While f_StartScrolling
    Set lastPiclegend = PicLegend(PicLegend.UBound)
    
    With picScrollWindow
        If (f_lngScrollTop + ScaleHeight) > 0 Then
          .Top = 0
        Else
          .Top = f_lngScrollTop + ScaleHeight
        End If
        f_lngScrollTop = .Top
        .Refresh
    End With
    setScrollBarVisible
    Set lastPiclegend = Nothing
   'Forces a delay
    For i = 0 To 1000000
    Next
    
    DoEvents
  Loop
End Sub

Private Sub cmdScrollUpPage_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  f_StartScrolling = False
End Sub

Private Sub PicLegend_DblClick(Index As Integer)
  If m_enabled Then
    If m_MapSource Is Nothing Then
      Exit Sub
    ElseIf m_MapSource.Layers.Count = 0 Then
      Exit Sub
    End If
    '
    ' set the clicked layer active
    If Not f_ClickOnRenderer Then
      Active(Index) = True
      RaiseEvent LayerDblClick(Index)
    End If
  End If
End Sub

Private Sub PicLegend_DragDrop(Index As Integer, Source As Control, X As Single, Y As Single)
  If m_enabled Then
    dragDrop Index
  End If
End Sub


Private Sub PicLegend_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
   If m_enabled Then
     If m_MapSource Is Nothing Then
       Exit Sub
     ElseIf m_MapSource.Layers.Count = 0 Then
       Exit Sub
     End If
     
     f_curActiveLayer = getActiveLayer
     
    f_ClickOnRenderer = True
    'activate the layer only if the click is not on the renderer
    If Not Renderer_Click(Index, X, Y) Then
       'Disable the old layer
       f_ClickOnRenderer = False
       If f_curActiveLayer = -1 Then
         'clears all other active layers
         Dim i As Integer
         i = 0
         While i <= PicLegend.UBound
           With PicLegend(i)
            ClearFrame i
            i = i + 1
           End With
         Wend
       Else
        ClearFrame f_curActiveLayer
      End If
      If f_curActiveLayer = Index Then
        'Disable the layer if already on (toggle on/off)
        With PicLegend(Index)
          Frame PicLegend(Index), stErase
        End With
        PicLegend(Index).Tag = ""
        f_curActiveLayer = -1
      Else
        With PicLegend(Index)
          Frame PicLegend(Index), stRaised
        End With
        PicLegend(Index).Tag = "Active"
        f_curActiveLayer = Index
      End If
     
     
      f_curIndex = Index
      If m_enableDragDrop And (m_MapSource.Layers.Count > 1) Then
        PicLegend(Index).Drag vbBeginDrag
      End If
     
     
     End If
     
     
     'Call Renderer_Click(Index, X, Y)
     
     RaiseEvent MouseDown(Index, Button, Shift, X, Y)
 End If
End Sub


Private Sub PicLegend_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
  If m_enabled Then
    If m_MapSource Is Nothing Then
      Exit Sub
    ElseIf m_MapSource.Layers.Count = 0 Then
      Exit Sub
    End If
      RaiseEvent MouseMove(Index, Button, Shift, X, Y)
  End If
End Sub

Private Sub PicLegend_MouseUp(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
  If m_enabled Then
    If m_MapSource Is Nothing Then
      Exit Sub
    ElseIf m_MapSource.Layers.Count = 0 Then
      Exit Sub
    End If
      RaiseEvent MouseUp(Index, Button, Shift, X, Y)
  End If
End Sub

Private Function Renderer_Click(Index As Integer, X As Single, Y As Single) As Boolean
  Dim RendererIndex As Integer
  Dim lyrIndex As Integer
  
  Dim val1 As Variant, val2 As Variant
  Renderer_Click = False
  lyrIndex = Index
  'First we check if the click occured on top of a renderer
  RendererIndex = CheckClickOnRenderer(Index, X, Y)
  If RendererIndex = -1 Then
    Exit Function
  End If
  On Error Resume Next
  'lyrIndex = PicLegendRenderer(Index).Tag
  
  Dim lyr As New MapObjects2.MapLayer
  Set lyr = m_MapSource.Layers(lyrIndex)
  Dim lyrRenderer As Object
  Set lyrRenderer = lyr.Renderer
  If Not lyrRenderer Is Nothing Then
    If TypeOf lyrRenderer Is MapObjects2.ValueMapRenderer Then
      val1 = lyrRenderer.Value(RendererIndex)
      If Err.Number <> 0 Then
        Err.Clear
        RendererIndex = -1
      End If
    ElseIf TypeOf lyrRenderer Is MapObjects2.ClassBreaksRenderer Then

      ' Get the lower limit for the break
      If RendererIndex = 0 Then
        val1 = -1.79769313486232E+307 ' Return a very big negative double
      Else
        val1 = lyrRenderer.Break(RendererIndex - 1)
      End If
      ' Get the upper limit for the break
      If RendererIndex = lyrRenderer.BreakCount Then
        val2 = 1.79769313486232E+307 ' Return a very big positive double
      Else
        val2 = lyrRenderer.Break(RendererIndex)
      End If
    ElseIf TypeOf lyrRenderer Is MapObjects2.DotDensityRenderer Then
      val1 = lyrRenderer.DotValue
    End If
    
    If m_enabled Then
      'RaiseEvent RenderClick(Val(lyrIndex), val1, val2)
      If RendererIndex >= 0 Then
        RaiseEvent RenderClick(Val(lyrIndex), RendererIndex, val1, val2)
      End If
    End If
  End If
  Renderer_Click = True
  Set lyr = Nothing
  Set lyrRenderer = Nothing
  
End Function


Public Sub LoadLegend(Optional ShowCheck As Boolean = True)
Attribute LoadLegend.VB_Description = "Makes legends for all  the layers contained in the map control."
  '
  ' For each layer, the legend is made of a picture box (picLegend),
  ' Check box (chkLegend), number of picLegendRenderers and
  ' label controls (lblLegend). There is a set of these controls
  ' preloaded in the usercontrol, when needed, more will be loaded
  ' on the fly.
  ' In order for chklegend, PicLegendRenderer and LblLegend to always
  ' appear on top of the picLegend after they are loaded, we need to
  ' make lblLegend and chklegend contained within picLegend, while
  ' picLegendRenderer unbounded with the piclegend. So, labels and checkboxes
  ' have relative coordinates with picLegend, while piclegendrenderer have
  ' absolute coordinates within usercontrol.
  ' PiclegendRenderer and lblLegend have layer index as their tag
  ' to identify which layer they belong to.
  ' For a label to show on top of a picture box, it has to be
  ' contained by the picture, and zorder set to 0.
  ' CheckBox can always show on top, regardless it's contained
  ' by picture or not.
  
  On Error Resume Next

  f_isLoading = True
  
  'make sure there's mapsource for the legend
  If m_MapSource Is Nothing Then Exit Sub
  
  'Dim iCurLegend() As Integer
  'f_bLoading = True
  Dim CurLegend As New Collection
  
  Dim sym As MapObjects2.Symbol
  Dim renderType As Integer
  
  Dim i As Integer, j As Integer
  Dim lyr As Object
  Dim itemCount As Integer
  Dim lyrCount As Integer
  Dim newLegend As New clsLegendRenderer
  
  Dim lblLegendTop As Long
  Dim lblLegendLeft As Long
  Dim lblLegendText As String
  
  Dim lblRendererTop As Long
  Dim lblRendererText As String
  Dim HeightPictureRenderer As Long
  Dim PicLegendRendererTop As Long
  
  Dim isLegendVisible As Boolean
  
  Dim legenditems() As LegendArray
  
  'ReDim iCurLegend(0)
  Set CurLegend = Nothing
  If chkLegend.UBound >= 0 Then
    If Len(chkLegend(0).Caption) Then
      For i = 0 To chkLegend.UBound
        'ReDim Preserve iCurLegend(i)
        CurLegend.Add chkLegend(i).Value, chkLegend(i).Caption
        'iCurLegend(i) = chkLegend(i).Value
      Next
    End If
  End If
  '
  ' if there are existing legends, remove them first
  '
  
  'Initialize the renderer
  With newLegend
    .RendererHeight = PICTURE_RENDERER_HEIGHT
    .RendererWidth = PICTURE_RENDERER_WIDTH
  End With
  
  RemoveAll
  DoEvents
  
  HeightPictureRenderer = PicLegend(0).ScaleY(PICTURE_RENDERER_WIDTH, vbPixels, PicLegend(0).ScaleMode) ' * Screen.TwipsPerPixelY) + (2 * f_bigGap)
  '
  'exit if there isn't any layer
  lyrCount = m_MapSource.Layers.Count - 1
  If lyrCount = -1 Then Exit Sub
  
  chkLegend(0).Move 75, 1425, 225, 255
  ReDim f_RendererCaption(0)
  f_numOfEntries = 0   'num of legend items
  
  PicLegend(0).Top = -10
  For i = 0 To lyrCount
    With PicLegend(i)
      Set lyr = m_MapSource.Layers.Item(i)
      
      'Load the picture legend
      If i > 0 Then
        Load PicLegend(i)
        Load chkLegend(i)
        .Top = PicLegend(i - 1).Top + PicLegend(i - 1).Height
      End If
      lblLegendTop = f_bigGap
      
      'Define the legend for the layer
      lblLegendText = GetLayerLabelText(lyr)
       
      'Position of the picture and the check box
      
      .ZOrder 0
      .Visible = True
      chkLegend(i).ZOrder 0
      chkLegend(i).Visible = ShowCheck
      Set chkLegend(i).Container = PicLegend(i)
      chkLegend(i).Top = lblLegendTop + (.TextHeight(lblLegendText) / 2) - (chkLegend(i).Height / 2) + f_smallGap
      If Not ShowCheck Then
        lblLegendLeft = chkLegend(i).Left
      Else
        lblLegendLeft = LEFT_LBLTHEME
      End If
      chkLegend(i).Caption = lblLegendText
      If Not CurLegend Is Nothing Then
        If CurLegend.Count > 0 Then
          chkLegend(i).Value = CurLegend.Item(lblLegendText)
          If Err.Number <> 0 Then
            Err.Clear
            'chkLegend(i).Value = 0
            chkLegend(i).Value = IIf(lyr.Visible, 1, 0)
          End If
        Else
          chkLegend(i).Value = IIf(lyr.Visible, 1, 0)
        End If
      Else
        If chkLegend(i).Value <> IIf(lyr.Visible, 1, 0) Then
          chkLegend(i).Value = IIf(lyr.Visible, 1, 0)
        End If
      End If
      
      'Display the Label
      .AutoRedraw = True
      .ForeColor = f_TextColor
      .Width = IIf(lblLegendLeft + .TextWidth(lblLegendText) > ScaleWidth, lblLegendLeft + .TextWidth(lblLegendText), ScaleWidth)
      .CurrentX = lblLegendLeft
      .CurrentY = lblLegendTop
       PicLegend(i).Print lblLegendText
      .CurrentY = f_bigGap + chkLegend(i).Height
      
      
      isLegendVisible = ShowLegend(i)
      If TypeOf lyr Is MapObjects2.ImageLayer Or (Not isLegendVisible) Then
        'no renderer for imagelayer
        .Height = (2 * f_bigGap) + chkLegend(i).Height
      Else
        lblRendererTop = .CurrentY '+ f_smallGap
         
         'get layer symbols and corresponding values as default
         'text descriptions
         ReDim legenditems(0)
         LayerSymArrayMake lyr, legenditems
         Err.Clear
         'On Error Resume Next
         itemCount = UBound(legenditems) - 1 'within one layer
         If Err <> 0 Then
           itemCount = -1
           PicLegend(i).Height = f_bigGap + PicLegend(i).CurrentY '+ f_bigGap
           Err = 0
         End If
         
          If itemCount >= 0 Then
             For j = 0 To itemCount
               lblRendererText = legenditems(j).label
               
               PicLegendRendererTop = .CurrentY '+ f_smallGap
               'If itemCount = j Then PicLegendRendererTop = PicLegendRendererTop + f_smallGap
               .Height = PicLegendRendererTop + HeightPictureRenderer
               
               'Write the label for the renderer
               .CurrentX = LABEL_RENDERER_LEFT
               .CurrentY = PicLegendRendererTop
'               Debug.Print "X: " & .CurrentX
'               Debug.Print "Y: " & .CurrentY
               
               PicLegend(i).Print lblRendererText
               
               'Add the picture
               With newLegend
                 Set .PictureBox = PicLegend(i)
                 Set sym = legenditems(j).Symbol
                 Call .AddEntry(False, sym, PicLegendRendererTop, PICTURE_RENDERER_LEFT)
               End With
               
               .CurrentY = PicLegendRendererTop + HeightPictureRenderer
               .Height = .CurrentY + f_bigGap 'PicLegendRendererTop + (PICTURE_RENDERER_WIDTH * Screen.TwipsPerPixelY) + (2 * f_bigGap)
               
               'Save the renderer caption
               If Len(lblRendererText) Then
                 ReDim Preserve f_RendererCaption(UBound(f_RendererCaption) + 1)
                 With f_RendererCaption(UBound(f_RendererCaption))
                   .Caption = lblRendererText
                   .LayerIndex = i
                   .RendererIndex = j
                 End With
               End If
             Next j
          End If
          '.CurrentY = .CurrentY + f_smallGap
      End If
    End With
  Next i
  
  '
  ' resize picScrollWindow
  picScrollWindow.Height = PicLegend(PicLegend.UBound).Top _
                           + PicLegend(PicLegend.UBound).Height + 60
  picScrollWindow.Top = 0
  f_lngScrollTop = 0
  
  'need to show scroll buttons
  setScrollBarVisible
  
  'make those public events available to users
  m_enabled = True
  '
  'clean up
  Set newLegend = Nothing
  Set sym = Nothing
  Set lyr = Nothing
  Set CurLegend = Nothing
  Erase legenditems
  
  i = 0: j = 0:  itemCount = 0
  lyrCount = 0
  
  'f_bLoading = False
  f_isLoading = False
  
End Sub


Private Sub setScrollBarVisible()
On Error Resume Next
  
  Dim maxHeight As Single
  maxHeight = PicLegend(PicLegend.UBound).Top + PicLegend(PicLegend.UBound).Height
    
  With cmdScrollUp
    If f_lngScrollTop < 0 Then
      .Visible = True
      cmdScrollUpPage.Visible = True
    Else
      .Visible = False
      cmdScrollUpPage.Visible = False
    End If
  End With
  
  With cmdScrollDown
     If maxHeight + f_lngScrollTop > UserControl.Height Then
       .Visible = True
       cmdScrollDownPage.Visible = True
     Else
       .Visible = False
       cmdScrollDownPage.Visible = False
     End If
  End With
  '
  ' make sure the active layer is maintained
  '
  Dim ActiveLyr As Integer
  ActiveLyr = getActiveLayer
  If ActiveLyr > -1 Then
    Active(ActiveLyr) = True
  End If

End Sub
Private Sub CreateGroupRenderer(groupRend As MapObjects2.GroupRenderer, legenditems() As LegendArray)
  Dim rend As Object
  Dim i As Integer
 
  For i = 0 To groupRend.Count - 1
    Set rend = groupRend.Renderer(i)
    If Not (TypeOf rend Is LabelRenderer Or TypeOf rend Is LabelPlacer) Then
      Select Case True
        
        Case TypeOf rend Is MapObjects2.ClassBreaksRenderer
          CreateBreakArray rend, legenditems
          
        Case TypeOf rend Is MapObjects2.ValueMapRenderer
          CreateValueArray rend, legenditems
           
        Case TypeOf rend Is MapObjects2.DotDensityRenderer
          CreateDotArray rend, legenditems
      End Select
    End If
  Next
End Sub
Private Sub LayerSymArrayMake(lyr As MapObjects2.MapLayer, legenditems() As LegendArray)
  'For a given layer, this procedure returns an array of legenditems
  ' which contain legend symbol and label for each item
  '
  'On Error Resume Next
  Dim myRend As Object
    
  ReDim legenditems(0)
  'Exctract the rendrer from the group if any
  Set myRend = GetGraphicRenderer(lyr.Renderer, True)
  
  If myRend Is Nothing Then
    ReDim Preserve legenditems(1)
    Set legenditems(0).Symbol = lyr.Symbol
    legenditems(0).label = ""
    Exit Sub
  End If
  
  Select Case True
    
    Case TypeOf myRend Is MapObjects2.ClassBreaksRenderer
      CreateBreakArray myRend, legenditems
      
    Case TypeOf myRend Is MapObjects2.ValueMapRenderer
      CreateValueArray myRend, legenditems
       
    Case TypeOf myRend Is MapObjects2.DotDensityRenderer
      CreateDotArray myRend, legenditems
      
    Case TypeOf myRend Is MapObjects2.GroupRenderer
      CreateGroupRenderer myRend, legenditems
      
    Case Else
      ReDim Preserve legenditems(1)
      Set legenditems(0).Symbol = lyr.Symbol
      legenditems(0).label = lyr.Name
  End Select
End Sub

Public Sub RemoveAll()
Attribute RemoveAll.VB_Description = "Clears  the legend control."
  'On Error Resume Next
  
  Dim i As Integer
  Dim cnt As Long
    'move lbllegend(0) and lbltheme(0) back to original place
  cnt = PicLegend.UBound
  For i = 1 To cnt
    Unload chkLegend(i)
    PicLegend(i).AutoRedraw = False
    Set PicLegend(i) = Nothing
    Unload PicLegend(i)
  Next
  chkLegend(0).Caption = ""
  chkLegend(0).Visible = False
  With PicLegend(0)
    .Visible = False
    .AutoRedraw = False
    .Cls
  End With
  Set PicLegend(0) = Nothing
    
  cmdScrollDown.Visible = False
  cmdScrollUp.Visible = False
  cmdScrollDownPage.Visible = False
  cmdScrollUpPage.Visible = False
End Sub



Private Sub PicPanel_DragDrop(Source As Control, X As Single, Y As Single)
  If m_enabled Then
    dragDrop PicLegend.UBound
  End If

End Sub

Private Sub PicPanel_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
RaiseEvent MouseDown(-1, Button, Shift, X, Y)
End Sub

Private Sub picScrollWindow_DragDrop(Source As Control, X As Single, Y As Single)
  If m_enabled Then
    dragDrop PicLegend.UBound
  End If
End Sub

Private Sub picScrollWindow_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  RaiseEvent MouseDown(-1, Button, Shift, X, Y)
End Sub

Private Sub picScrollWindow_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  RaiseEvent MouseMove(-1, Button, Shift, X, Y)
End Sub

Private Sub picScrollWindow_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
RaiseEvent MouseUp(-1, Button, Shift, X, Y)
End Sub

Private Sub UserControl_Initialize()
  f_bigGap = 70
  f_smallGap = 20
  f_lngScrollTop = 0
  f_curActiveLayer = -1
  f_numOfEntries = 0
  m_enableDragDrop = True
  ReDim Preserve f_RendererCaption(0)
  f_TextColor = &H0
  f_StartScrolling = False
  'f_bLoading = False
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
  m_BackColor = moWhite
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    'back color
    If m_BackColor = moBlack Then
      m_BackColor = moWhite
    End If
    With UserControl
      .BackColor = PropBag.ReadProperty("BackColor", m_BackColor)
      PicPanel.BackColor = .BackColor
      picScrollWindow.BackColor = .BackColor
      PicLegend(0).BackColor = .BackColor
      chkLegend(0).BackColor = .BackColor
      cmdScrollDown.BackColor = .BackColor
      cmdScrollDownPage.BackColor = .BackColor
      cmdScrollUp.BackColor = .BackColor
      cmdScrollUpPage.BackColor = .BackColor
    End With
    'font
    With UserControl
      Set .Font = PropBag.ReadProperty("Font", Ambient.Font)
      Set PicLegend(0).Font = .Font
    End With
    'fore color
    With UserControl
      .ForeColor = PropBag.ReadProperty("foreColor", m_foreColor)
      chkLegend(0).ForeColor = .ForeColor
    End With
    
    UserControl.BackStyle = PropBag.ReadProperty("BackStyle", 1)
    UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
    
    Set m_MapSource = PropBag.ReadProperty("MapSource", Nothing)
    
    UserControl.Refresh
End Sub

Private Sub UserControl_Resize()
  On Error Resume Next
  
   Dim i, k, l, Item As Integer, PicHeight As Single
   Dim legCaption As String
   Dim lastLegendItem As Variant
   Dim deltaX As Single
   Dim legThemeNameWidth As Single
   Dim legLblWidth As Single
   Dim legPicWidth As Single
         
   i = 0: k = 0: l = 0: Item = 0
   deltaX = ScaleWidth - PicPanel.Width
   
   PicPanel.Move 0, 0, ScaleWidth, ScaleHeight
   picScrollWindow.Left = 0
   picScrollWindow.Top = 0
   picScrollWindow.Width = ScaleWidth
    
   For i = 0 To PicLegend.UBound
    PicLegend(i).Left = -10
    PicLegend(i).Width = ScaleWidth
   Next
   
   
'   If deltaX <> 0 Then
'      legThemeNameWidth = deltaX 'LblTheme(0).width +
'      legLblWidth = deltaX 'LblLegend(0).width +
'      legPicWidth = PicLegend(0).Width + deltaX
'      'reset picLegend and chkLegend width
'      Do While k <= PicLegend.UBound
'        PicLegend(k).Width = legPicWidth
'        'LblTheme(k).width = legThemeNameWidth
'        k = k + 1
'      Loop
'      'reset lblLegend width
'
'      'set picLegend top
'      Do While i <= PicLegend.UBound
'        With PicLegend(i)
'          If i = 0 Then
'            .Top = 0
'          Else
'            .Top = PicLegend(i - 1).Top + PicLegend(i - 1).Height
'          End If
'        End With
'
'        With PicLegend(i)
'          If TypeOf lastLegendItem Is CheckBox Then
'            .Height = lastLegendItem.Top + lastLegendItem.Height + f_bigGap _
'                      - PicLegend(i).Top
'          Else
'            .Height = lastLegendItem.Top + lastLegendItem.Height + f_bigGap
'          End If
'        End With
'        i = i + 1
'      Loop
'      '
'      'stretching the control can possibly make the legend shorter,
'      ' if f_lngscrollTop is lower than the current bottom of the last
'      ' piclegend, then make sure the piclegend doesn't go beyond
'      ' the control.
'      Dim picBottom As Single
'      picBottom = PicLegend(i - 1).Top _
'                  + PicLegend(i - 1).Height + f_lngScrollTop
'      picScrollWindow.Height = PicLegend(i - 1).Top + PicLegend(i - 1).Height + 20
'
'      With picScrollWindow
'        If (f_lngScrollTop < 0) And (picBottom < ScaleHeight) Then
'           .Top = f_lngScrollTop + (ScaleHeight - picBottom)
'           f_lngScrollTop = .Top
'           setScrollBarVisible
'        Else
'          .Top = f_lngScrollTop
'        End If
'      End With
'   End If
   'reset variable, the top of picscrollwindow may be changed by
   ' application
    f_lngScrollTop = picScrollWindow.Top
   '
   ' reposition scrolls
   '
    With cmdScrollUp
      .Left = ScaleWidth - .Width - 50
      .Top = cmdScrollUpPage.Height + 30
      cmdScrollUpPage.Left = .Left
      cmdScrollUpPage.Top = 30
    End With
    With cmdScrollDown
      .Left = ScaleWidth - .Width - 20
      .Top = ScaleHeight - cmdScrollDownPage.Height - .Height - 15
      cmdScrollDownPage.Left = .Left
      cmdScrollDownPage.Top = ScaleHeight - cmdScrollDownPage.Height - 10
    End With
  
  setScrollBarVisible
  '
  'clean up
  Set lastLegendItem = Nothing
End Sub

Private Sub UserControl_Terminate()
  'remove legend
  RemoveAll
  
  Set m_MapSource = Nothing
  Set m_showLegendCol = Nothing
  
  f_bigGap = 0
  f_smallGap = 0
  f_lngScrollTop = 0
  f_curActiveLayer = -1
  f_numOfEntries = 0
  Erase f_RendererCaption
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, moWhite)
    Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, moBlack)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("Font", UserControl.Font, Ambient.Font)
    Call PropBag.WriteProperty("BackStyle", UserControl.BackStyle, 1)
    Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
    Call PropBag.WriteProperty("Caption", chkLegend(0).Caption, "")
    Call PropBag.WriteProperty("MapSource", m_MapSource, Nothing)
End Sub

Public Property Get LayerLabels(lyrIndex As Integer)
Attribute LayerLabels.VB_MemberFlags = "40"
  'get an array of labels for the specified layer
  Dim i As Integer, j As Integer
  Dim legendLabels() As String
  Dim nCount As Integer
  nCount = UBound(f_RendererCaption)
  i = 0
  j = 0
  Do While i <= nCount
    If f_RendererCaption(i).LayerIndex = lyrIndex Then
      ReDim Preserve legendLabels(j + 1)
      legendLabels(j) = f_RendererCaption(i).Caption
      j = j + 1
    End If
    i = i + 1
  Loop
  LayerLabels = legendLabels
  
End Property

Public Property Let LayerLabels(lyrIndex As Integer, ByVal vNewValue As Variant)
  Dim i As Integer, j As Integer, lowBnd As Integer
  Dim legendLabels() As String
  Dim nCount As Integer
  i = 0
  j = 0
  nCount = UBound(f_RendererCaption)
  lowBnd = LBound(vNewValue)
  Do While i <= nCount
    If f_RendererCaption(i).LayerIndex = lyrIndex Then
      f_RendererCaption(i).Caption = vNewValue(lowBnd + j)
      j = j + 1
    End If
    i = i + 1
  Loop
  
  PropertyChanged "label"
End Property
Private Sub Frame(thePic As PictureBox, Style As FrameStyle)

    Const HiColor = &HFFFFFF
    Const LoColor = &H808080
    
    Dim Offset As Integer
    
    Offset = 20
    
    thePic.DrawWidth = 1
    thePic.ForeColor = HiColor: If Style = stRaised Then thePic.ForeColor = LoColor
    'case we need to erase the frame
    If Style = stErase Then thePic.ForeColor = thePic.BackColor
    
    With thePic
'      'bottom:
'      thePic.Line (.DrawWidth + Offset, .Height - Offset)-(RightBorder - Offset - .DrawWidth, .Height - Offset)
'      'right:
'      thePic.Line (RightBorder - Offset, .DrawWidth + Offset)-(RightBorder - Offset, .Height - Offset - .DrawWidth)
      
      thePic.Line (-10, .Height - Offset)-(.Width, .Height - Offset)
      
      .ForeColor = LoColor: If Style = stRaised Then .ForeColor = HiColor
      
      'case we need to erase the frame
      If Style = stErase Then .ForeColor = thePic.BackColor
      'top:

      thePic.Line (-10, Offset)-(.Width, Offset)

'      thePic.Line (BigOffSet + .DrawWidth + Offset, Offset + BigOffSet)-(RightBorder + BigOffSet - Offset - .DrawWidth, Offset + BigOffSet)
'       'left:
'      thePic.Line (Offset + BigOffSet, .DrawWidth - BigOffSet + Offset)-(Offset + BigOffSet, .Height + BigOffSet - .DrawWidth - Offset)
    End With
End Sub

Public Property Get Active(Index As Integer) As Boolean
Attribute Active.VB_Description = "Returns or sets a value indicating whether a  layer is active or inactive."
  On Error Resume Next
  
  'make sure it's a valid layer
  If Index >= m_MapSource.Layers.Count Then
    Exit Property
  End If

  Active = IIf(PicLegend(Index).Tag = "Active", True, False)
End Property

Public Property Let Active(Index As Integer, ByVal vNewValue As Boolean)
  On Error Resume Next
  
  'make sure it's a valid layer
  If Index >= m_MapSource.Layers.Count Then
    Exit Property
  End If

  If Index > -1 Then
    PicLegend(Index).AutoRedraw = True
    m_bActive = vNewValue
    If vNewValue Then
      'clears all other active layers
      Dim i As Integer
      i = getActiveLayer
      If i > -1 Then ClearFrame i
'      While i <= PicLegend.UBound
'      ClearFrame i
'        i = i + 1
'      Wend
      'activate the layer
      With PicLegend(Index)
        Frame PicLegend(Index), stRaised
      End With
      PicLegend(Index).Tag = "Active"
    Else
      ClearFrame Index
    End If
    
    PropertyChanged "Active"
  End If
End Property

Public Function getActiveLayer() As Integer
Attribute getActiveLayer.VB_Description = "Returns the active layer index number, -1 indicates no active layer."
  On Error Resume Next
  
  'returns active layer index
  'if no layer is active, then return -1
  getActiveLayer = -1
  Dim i As Integer
  i = 0
  If Not m_MapSource Is Nothing Then
    Do While i <= PicLegend.UBound
      If PicLegend(i).Tag = "Active" Then
        getActiveLayer = i
        Exit Do
      End If
      i = i + 1
    Loop
  End If
End Function


Public Sub setMapSource(map As Object)
Attribute setMapSource.VB_Description = "Set the map control as the source of the legend control."
  On Error Resume Next
  Set m_MapSource = map
End Sub

Public Property Get LayerVisible(Index As Integer) As Boolean
Attribute LayerVisible.VB_Description = "Returns or sets a value indicating whether a layer is visible or hidden."
On Error Resume Next
  LayerVisible = IIf(chkLegend(Index) = 1, True, False)
End Property

Public Property Let LayerVisible(Index As Integer, ByVal vNewValue As Boolean)
  chkLegend(Index).Value = IIf(vNewValue, 1, 0)
End Property

Public Property Get ShowLegend(lyrIndex As Integer) As Boolean
Attribute ShowLegend.VB_Description = "Returns/sets a value indicating weather to show or hide the layer symbology on the legend control."
  'make sure it's a valid layer
  If lyrIndex >= m_MapSource.Layers.Count Then
    Exit Property
  End If
  
  Dim findIndex As Integer
  findIndex = findItem(m_MapSource.Layers.Item(lyrIndex).Name, lyrIndex)
  If findIndex = -1 Then
    ShowLegend = True
  Else
    ShowLegend = m_showLegendCol(findIndex).LegendVisible
  End If
End Property

Public Property Let ShowLegend(lyrIndex As Integer, ByVal vNewValue As Boolean)
  'make sure it's a valid layer
  If lyrIndex >= m_MapSource.Layers.Count Then
    Exit Property
  End If
  
  Dim findIndex As Integer
  Dim lyrName As String
  lyrName = m_MapSource.Layers.Item(lyrIndex).Name
  findIndex = findItem(lyrName, lyrIndex)
  If findIndex <> -1 Then
    m_showLegendCol.Remove findIndex
  End If
  'add
  Dim theTheme As New cTheme
  With theTheme
    .Index = lyrIndex
    .Name = lyrName
    .LegendVisible = vNewValue
  End With
  m_showLegendCol.Add theTheme
  '
End Property

Private Function findItem(lyrName As String, lyrIndex As Integer) As Integer
  'used to find if a layer's legend has been set to visible/invisible
  findItem = -1
  Dim i As Integer
  For i = 1 To m_showLegendCol.Count
    If UCase(m_showLegendCol(i).Name) = UCase(lyrName) And _
       (m_showLegendCol(i).Index = lyrIndex) Then
       findItem = i
       Exit For
    End If
  Next
End Function

Public Sub ShowAllLegend()
Attribute ShowAllLegend.VB_Description = "Shows all the layers' symbology in the legend control."
On Error Resume Next
Dim i As Integer
For i = 0 To m_MapSource.Layers.Count - 1
  ShowLegend(i) = True
Next
End Sub
Public Sub HideAllLegend()
Attribute HideAllLegend.VB_Description = "Hides all layers' symbology in the legend control."
On Error Resume Next
Dim i As Integer
For i = 0 To m_MapSource.Layers.Count - 1
  ShowLegend(i) = False
Next
End Sub

Private Function isSymbolTransparant(aSym As MapObjects2.Symbol) As Boolean
  isSymbolTransparant = False
  
  Select Case aSym.symboltype
    Case moFillSymbol
      'If  Then
        isSymbolTransparant = (aSym.Style = moTransparentFill And (Not aSym.Outline))
      'End If
    Case moPointSymbol, moLineSymbol
  '    If aSym.Size = 0 Then
  '      isSymbolTransparant = True
  '    End If
  '  Case moLineSymbol
      'If  Then
        isSymbolTransparant = (aSym.Size = 0)
      'End If
    Case Else
  End Select
End Function

Private Function CheckClickOnRenderer(Index As Integer, X As Single, Y As Single) As Integer
  Dim CurrentPos As Single
  Dim RendererIndex As Integer
  Dim PictureHeight As Single
  
  
  
  CheckClickOnRenderer = -1
  If X < PICTURE_RENDERER_LEFT Or X > (PICTURE_RENDERER_LEFT + (PICTURE_RENDERER_WIDTH * Screen.TwipsPerPixelX)) Then Exit Function
  'At this poijnt the x is i range
  PictureHeight = PICTURE_RENDERER_HEIGHT * Screen.TwipsPerPixelY
  'CurrentPos = chkLegend(Index).Height + f_bigGap + f_smallGap
  CurrentPos = chkLegend(Index).Height + f_smallGap
  RendererIndex = 0
  Do Until CurrentPos > PicLegend(Index).Height
    If Y >= CurrentPos And Y <= CurrentPos + PictureHeight Then
      CheckClickOnRenderer = RendererIndex
      Exit Function
    End If
    CurrentPos = CurrentPos + PictureHeight '+ f_smallGap
    RendererIndex = RendererIndex + 1
  Loop
     
     
End Function
Private Sub ClearFrame(Index As Integer)
  If Index < 0 Or Index > PicLegend.UBound Then Exit Sub
  Frame PicLegend(Index), stErase
  PicLegend(Index).Tag = ""
End Sub

Private Function GetLayerLabelText(lyr As Object) As String
  Dim strTemp As String
  Dim TempObj As Object
  
  strTemp = UCase$(lyr.Name)
    
  'case the layer is an image
  If TypeOf lyr Is MapObjects2.ImageLayer Then
    strTemp = strTemp & " (Image)"
    GoTo EXIT_GetLayerLabelText
  End If
  
  'Case has a renderer
  If Not lyr.Renderer Is Nothing Then
    Set TempObj = GetGraphicRenderer(lyr.Renderer)
    If Not TempObj Is Nothing Then strTemp = strTemp & " (" & TempObj.Field & ")"
  End If
  
EXIT_GetLayerLabelText:
  GetLayerLabelText = strTemp
End Function

Private Function GetGraphicRenderer(ByVal rend As Object, Optional GetGroupRenderer As Boolean = False) As Object
  Dim obj As Object
  Dim i As Integer
  Set GetGraphicRenderer = Nothing
  
  If rend Is Nothing Then Exit Function
  
  If TypeOf rend Is LabelRenderer Or TypeOf rend Is LabelPlacer Then
    Exit Function
  End If
  
  If Not GetGroupRenderer Then
    If TypeOf rend Is MapObjects2.GroupRenderer Then
      For i = 0 To rend.Count - 1 ' gRend In rend
        Set obj = GetGraphicRenderer(rend.Renderer(i))
        If Not obj Is Nothing Then
          Set GetGraphicRenderer = obj
          Exit Function
        End If
      Next
    End If
  
  End If
  
  Set GetGraphicRenderer = rend
  
End Function

Private Sub CreateBreakArray(myRend As Object, legenditems() As LegendArray)
  Dim j As Long
  Dim difval As Double
  Dim b99 As Boolean
  If myRend Is Nothing Then Exit Sub
  b99 = False
  
  With myRend
  ReDim legenditems(.BreakCount + 1)
   For j = 0 To .BreakCount
    If Not isSymbolTransparant(.Symbol(j)) Then
      ' ReDim Preserve legenditems(j)
       Set legenditems(j).Symbol = .Symbol(j)
       If j = 0 Then
         difval = (.Break(j)) - Int(.Break(j))
         If difval <> 0 Then
            legenditems(j).label = "Less than " & Format$(.Break(0), "##,##0.####")
         Else
            legenditems(j).label = "Less than " & Format$(.Break(0), "##,##0")
         End If
       ElseIf j = .BreakCount Then
         difval = (.Break(j - 1)) - Int(.Break(j - 1))
         If difval <> 0 Then
            legenditems(j).label = "Greater than " & Format$(.Break(j - 1), "##,##0.####")
         Else
            legenditems(j).label = "Greater than " & Format$(.Break(j - 1), "##,##0")
         End If
       Else
         difval = (.Break(j)) - Int(.Break(j))
         If difval <> 0 Then
            'legenditems(j).label = Format$(.Break(j - 1), "##,##0.###") & _
              " - " & Format$(.Break(j) , "##,##0.###")
            legenditems(j).label = Format$(.Break(j - 1), "##,##0.####") & _
              " - " & Format$(.Break(j), "##,##0.####")
            If legenditems(j).label = "" Then
               legenditems(j).label = ">= " & Format$(.Break(j - 1), "##,##0.####")
            End If
         Else
          If (.Break(j - 1) - .Break(j)) = 0 Then
              legenditems(j).label = Format$(.Break(j - 1), "##,##0") & _
                " - " & Format$(.Break(j), "##,##0.9998")
              b99 = True
          Else
            If b99 Then
              b99 = False
              legenditems(j).label = Format$(.Break(j - 1), "##,##0.9999") & _
                " - " & Format$(.Break(j) - 1, "##,##0")
            Else
              legenditems(j).label = Format$(.Break(j - 1), "##,##0") & _
                " - " & Format$(.Break(j) - 1, "##,##0")
            End If
          End If
          If .Break(j) = 0 Then
             Set legenditems(j).Symbol = .Symbol(.BreakCount)
             legenditems(j).label = ">= " & Format$(.Break(j - 1), "##,##0.####")
          End If
         End If
       End If
     End If
    Next
  End With
End Sub


Private Sub CreateValueArray(myRend, legenditems() As LegendArray)
  Dim j As Long
  If myRend Is Nothing Then Exit Sub
  With myRend
    ReDim legenditems(.ValueCount)
    For j = 0 To .ValueCount - 1
      ' ReDim Preserve legenditems(i)
       Set legenditems(j).Symbol = .Symbol(j)
       legenditems(j).label = .Value(j)
    Next
  End With
End Sub


Private Sub CreateDotArray(myRend, legenditems() As LegendArray)
  Dim j As Long
  Dim dotSym  As MapObjects2.Symbol
  If myRend Is Nothing Then Exit Sub
  With myRend
    ReDim legenditems(.ValueCount)
    For j = 0 To .ValueCount - 1
      legenditems(j).label = "Value: " & Str(.DotValue)
      Set dotSym = New MapObjects2.Symbol
      dotSym.symboltype = moPointSymbol
      dotSym.color = .DotColor
      Set legenditems(j).Symbol = dotSym
      Set dotSym = Nothing
    Next
  End With
End Sub

Public Function ExportToBmp(FileName As String, Optional LayerIndex As Integer = -1) As Boolean
  Dim X As New clsBitmapDC
  Dim mWidth As Long
  Dim mHeight As Long
  Dim HdcBitmap As Long
  Dim pic As Picture
  Dim TopSource As Long
  Dim i As Integer
  
  ExportToBmp = False
  
  'Calculate the dimension of the bitmap
  If LayerIndex = -1 Then
    'Create a legend picture for all the picture boxes
    With picScrollWindow
      mWidth = .ScaleX(.ScaleWidth, .ScaleMode, vbPixels)
      mHeight = .ScaleY(.ScaleHeight, .ScaleMode, vbPixels)
    End With
   Else
    With PicLegend(LayerIndex)
      mWidth = .ScaleX(.ScaleWidth, .ScaleMode, vbPixels)
      mHeight = .ScaleY(.ScaleHeight, .ScaleMode, vbPixels)
    End With
  End If


  'Create an Empty Bitmap
  HdcBitmap = X.CreateBitmapInMemory(mWidth, mHeight - 5, PicLegend(0).hDC)
  If HdcBitmap = -1 Then GoTo EXIT_ExportToBmp
  
  'Remove the Selection box if any
  ClearFrame f_curActiveLayer
  
  'at this point we have an empty bitmap
  If LayerIndex > -1 Then
    X.PasteBitmap HdcBitmap, 0, 0, PicLegend(LayerIndex).hDC, 0, 0, mWidth, mHeight
  Else
    TopSource = 0
    For i = 0 To PicLegend.UBound
      With PicLegend(i)
        X.PasteBitmap HdcBitmap, 0, TopSource, .hDC, 0, 0, .ScaleX(.ScaleWidth, .ScaleMode, vbPixels), .ScaleY(.ScaleHeight, .ScaleMode, vbPixels)
        TopSource = TopSource + .ScaleY(.ScaleHeight, .ScaleMode, vbPixels)
      End With
    Next
  End If
  Set pic = X.CreateBitmapPicture(HdcBitmap, 0)
  SavePicture pic, FileName
  
  'Restore the selection frame
  If f_curActiveLayer > -1 Then Frame PicLegend(f_curActiveLayer), stRaised
  
  ExportToBmp = True

EXIT_ExportToBmp:
  Set X = Nothing

End Function
